C
C     Programa Lagrafic.for
C
C     Pablo Lpez Cienfuegos.
C     Jorge Lpez Garca.
C
C     Este programa recibe los datos del mallado del dominio de una funcin, almacenados en
C     un fichero, y con estos datos y la propia funcin definida en una subrutina, realiza
C     una serie de operaciones con un punto introducido a travs del teclado por el usuario. 
C
      INCLUDE  'FGRAPH.FI'
      INCLUDE  'FGRAPH.FD'
C
C        Cargamos las bibliotecas grficas que empleamos en el programa. 
C
      EXTERNAL F
C
C        F:          Es la subrutina en la que se almacena la funcin que se emplea en el
C                    programa. 
C
      LOGICAL EXISTE,PERTE
C
C        Existe:     Es la variable que empleamos para comprobar si existe el archivo en
C                    el que el usuario dice que est almacenada la malla. 
C        Perte:      Es la variable que indica si el punto que se utiliza para el estudio
C                    se encuentra en el tringulo que estamos analizando en cada momento. 
C
      CHARACTER*80 FICHERO
C
C        Fichero:    Es la variable en la que guardamos el nombre del fichero que contiene
C                    la malla. 
C
      INTEGER AUX,OPCION,IND,NNOD,NTRI,NOD(1:3)
C
C        Aux:        Variable auxiliar para trabajar con los colores. 
C        Opcion:     Es la variable que utilizamos para manejar el menu en el que tratamos
C                    posibles errores en la apertura del fichero. 
C        Ind:        Es el contador que recorre los tringulos de la malla. 
C        Nnod:       Variable que almacena el nmero de nodos de la malla. 
C        Ntri:       Variable que almacena el nmero de tringulos de la malla. 
C        Nod(1:3):   Es el vector que utilizamos para almacenar los nodos del tringulo a
C                    estudiar. 
C
      REAL F,PIF,ERR,LANDA(1:3),E1,E2,DET,A,B,C,D,EG1,EG2,
     +   X[ALLOCATABLE](:),Y[ALLOCATABLE](:)
C
C        F:          Funcin a P1-interpolar. 
C        Pif:        Valor P1-interpolado de la funcin F. 
C        Err:        Diferencia entre el valor de la funcin y el valor P1-interpolado en el
C                    punto XI. 
C        Landa(1:3): Vector en el que se almacenan las coordenadas baricntricas. 
C        E1:         Variable en la que se almacena el valor de la primera coordenada del
C                    punto XI. 
C        E2:         Variable en la que se almacena el valor de la segunda coordenada del
C                    punto XI. 
C        Det:        Variable en la que se almacena el valor del determinante de la matriz
C                    del sistema afn. 
C        A,B,C,D:    Variables que utilizamos para almacenar los valores de la matriz inversa. 
C        Eg1:        Variable en la que almacenamos la primera coordenada del punto XI GORRO,
C                    que es el punto que se encuentra en el tringulo de referencia. 
C        Eg2:        Variable en la que almacenamos la segunda coordenada del punto XI GORRO,
C                    que es el punto que se encuentra en el tringulo de referencia. 
C        X,Y:        Vectores en los que almacenamos las coordenadas de los nodos. 
C

C
C        Una vez definidas las variables que empleamos en el programa, pasamos al cdigo
C        del programa en si. 
C

C
C        Para ver los posibles colores, buscar en la ayuda REMAPALLPALETTE.
C
      AUX=SETBKCOLOR(10)
      AUX=SETTEXTCOLOR(15)
C
      CALL CLEARSCREEN($GCLEARSCREEN)
C
C        Llamada al sistema para borrar la pantalla. 
C
      WRITE(*,*)' '
      WRITE(*,*)' '
      WRITE(*,*)'    Introduzca el nombre del fichero que contiene los',
     +          ' datos (max. 80 car.):'
      WRITE(*,*)' '
C
C        Aqu leemos el nombre del fichero. 
C
      READ(*,'(A)') FICHERO
C
C        Comprobacin de la existencia del fichero que introduce el usuario. 
C
      INQUIRE(FILE=FICHERO,EXIST=EXISTE)
      IF(.NOT.EXISTE) THEN
         AUX=SETBKCOLOR(12)
         CALL CLEARSCREEN($GCLEARSCREEN)
         WRITE(*,*)' '
         WRITE(*,*)' '
         WRITE(*,*)'    No existe el fichero ',FICHERO
         WRITE(*,*)'    Elija una de las siguientes opciones:'
      END IF
      DO WHILE(.NOT.EXISTE)
         WRITE(*,*)' '
         WRITE(*,*)' '
         WRITE(*,*)'          1-.   VOLVER A INTRODUCIR EL NOMBRE DEL',
     +             ' FICHERO'
         WRITE(*,*)'          2-.   SALIR DEL PROGRAMA'
         WRITE(*,*)' '
         READ(*,*) OPCION
         IF(OPCION.EQ.1) THEN
            AUX=SETBKCOLOR(10)
            CALL CLEARSCREEN($GCLEARSCREEN)
            WRITE(*,*)' '
            WRITE(*,*)' '
            WRITE(*,*)'            Introduzca el nombre del fichero',
     +                ' que contiene los datos:'
            WRITE(*,*)' '
            READ(*,'(A)') FICHERO
            INQUIRE(FILE=FICHERO,EXIST=EXISTE)
            IF(.NOT.EXISTE) THEN
               AUX=SETBKCOLOR(12)
               CALL CLEARSCREEN($GCLEARSCREEN)
               WRITE(*,*)' '
               WRITE(*,*)' '
               WRITE(*,*)'    No existe el fichero ',FICHERO
               WRITE(*,*)'    Elija una de las siguientes opciones:'
            END IF
         ELSE IF(OPCION.EQ.2) THEN
            STOP' '
         ELSE
            AUX=SETBKCOLOR(12)
            CALL CLEARSCREEN($GCLEARSCREEN)
            WRITE(*,*)' '
            WRITE(*,*)' '
            WRITE(*,*)'                     Elija una de las opciones',
     +                ' disponibles:'
         END IF
      END DO
C
C        Fin del menu de apertura al fichero. 
C        Comenzamos la ejecucin de la prctica. 
C      
      AUX=SETBKCOLOR(10)
      CALL CLEARSCREEN($GCLEARSCREEN)
      WRITE(*,*)' '
      WRITE(*,*)' '
      WRITE(*,*)'    Introduzca las coordenadas del punto en el que',
     +          ' quiere hacer el estudio:'
      WRITE(*,*)' '
      WRITE(*,*)'    Primera coordenada:'
      READ(*,*) E1
      WRITE(*,*)' '
      WRITE(*,*)'    Segunda coordenada:'
      READ(*,*) E2
      AUX=SETBKCOLOR(9)
      CALL CLEARSCREEN($GCLEARSCREEN)
      OPEN(1,FILE=FICHERO)
C
C        Saltamos la primera lnea de comentario del fichero obtenido del mallador. 
C
      READ(1,'(A$)')
      READ(1,*) NNOD,NTRI
      ALLOCATE(X(1:NNOD),Y(1:NNOD))
C
C        Saltamos la segunda lnea de comentario del fichero obtenido del mallador. 
C
      READ(1,'(A$)')
C
C        Almacenamos en los vectores X e Y las coordenadas de los nodos. 
C
      DO I=1,NNOD
         READ(1,*) X(I),Y(I)
      END DO
C
C        Saltamos la tercera lnea de comentario del fichero obtenido del mallador. 
C
      READ(1,'(A$)')
C
C        Inicializamos el contador del nmero de tringulo de la malla que estamos estudiando
C        (IND), e inicializamos a falso la variable PERTE. 
C
      PERTE=.FALSE.
      IND=0
      DO WHILE((.NOT.PERTE).AND.(IND.NE.NTRI))
         READ(1,*) NOD(1),NOD(2),NOD(3)
         IND=IND+1
C
C        Calculamos la inversa de la matriz del sistema afn. 
C
         DET=(X(NOD(1))-X(NOD(3)))*(Y(NOD(2))-Y(NOD(3)))-(X(NOD(2))-
     +      X(NOD(3)))*(Y(NOD(1))-Y(NOD(3)))
         A=(Y(NOD(2))-Y(NOD(3)))/DET
         B=(X(NOD(3))-X(NOD(2)))/DET
         C=(Y(NOD(3))-Y(NOD(1)))/DET
         D=(X(NOD(1))-X(NOD(3)))/DET
C
C        Calculamos las coordenadas cartesianas del punto XI GORRO del tringulo de referencia. 
C
         EG1=A*(E1-X(NOD(3)))+B*(E2-Y(NOD(3)))
         EG2=C*(E1-X(NOD(3)))+D*(E2-Y(NOD(3)))
C
C        Calculamos las coordenadas baricntricas de XI GORRO. 
C
         LANDA(1)=EG1
         LANDA(2)=EG2
         LANDA(3)=1-EG1-EG2
C
C        Comprobamos si XI GORRO pertenece al tringulo indicado por la variable IND. 
C
         IF((LANDA(1).GE.0).AND.(LANDA(1).LE.1).AND.(LANDA(2).GE.0).AND.
     +      (LANDA(2).LE.1).AND.(LANDA(3).GE.0).AND.(LANDA(3).LE.1))
     +      PERTE=.TRUE.
      END DO
      CLOSE(1)
C
C        Cuando el punto pertenece a un tringulo, escribimos el nmero que indica la posicin
C        del tringulo en la malla (IND), y damos los nodos del tringulo. 
C
      IF(PERTE) THEN
         WRITE(*,*)' '
         WRITE(*,*)' '
         WRITE(*,10) IND
         WRITE(*,*) NOD(1),NOD(2),NOD(3)
C
C        Si el punto no pertenece a ningn tringulo, damos un aviso y salimos del programa. 
C
      ELSE
         WRITE(*,*)' '
         WRITE(*,*)' '
         WRITE(*,*)'           El punto XI no pertenece a la clausura',
     +             ' del conjunto OMEGA'
         STOP' '
      END IF
C
C        Si el punto pertenece, continuamos con los dems apartados de la prctica. 
C
      WRITE(*,*)' '
      WRITE(*,*)'El punto XI GORRO es el punto de coordenadas:'
      WRITE(*,*) EG1,EG2
      WRITE(*,*)' '
      WRITE(*,*)'Las coordenadas baricentricas de XI son:'
      WRITE(*,*) LANDA(1),LANDA(2),LANDA(3)
      PIF=0.
C
C        Aqu realizamos el clculo del valor P1-interpolado. 
C
      DO I=1,3
         PIF=PIF+F(X(NOD(I)),Y(NOD(I)))*LANDA(I)
      END DO
      DEALLOCATE(X,Y)
C
C        Calculamos el error entre la funcin original y la P1-interpolada. 
C
      ERR=F(E1,E2)-PIF
      WRITE(*,*)' '
      WRITE(*,*)'PI(F(XI))=           ',PIF
      WRITE(*,*)' '
      WRITE(*,*)'E(F)=F(XI)-PI(F(XI))=',ERR
      WRITE(*,*)' '
      WRITE(*,*)' '
C
C        El formato de escritura que empleamos en el programa, es es siguiente: 
C
10    FORMAT(' El punto XI pertenece al triangulo',I5,' , que es de',
     +       ' nodos:')
      END
      