C
C     Programa Integra.for
C
C     Pablo Lpez Cienfuegos.
C     Jorge Lpez Garca.
C

C        En esta prctica, a partir de una triangulacin de un abierto
C        poligonal de R, tenemos que calcular el valor aproximado de
C        la integral de dicho abierto mediante la frmula de los
C        vrtices (orden 1), y mediante la de los puntos medios de los
C        lados (orden 2).
C
      INCLUDE 'FGRAPH.FI'
      INCLUDE 'FGRAPH.FD'
C
C        Cargamos las bibliotecas grficas que empleamos en el programa.
C
      EXTERNAL F
C
C        F:          Es la subrutina en la que se almacena la funcin
C                    que se emplea en el programa.
C
      LOGICAL EXISTE
C
C        Existe:     Es la variable que empleamos para comprobar si
C                    existe el archivo en el que el usuario dice que
C                    est almacenada la malla.
C
      CHARACTER*80 FICHERO
C
C        Fichero:    Es la variable en la que guardamos el nombre del
C                    fichero que contiene la malla.
C
      INTEGER OPCION,NNOD,NTRI,NOD(1:3)
C
C        Opcion:     Es la variable que utilizamos para manejar el menu
C                    en el que tratamos posibles errores en la apertura
C                    del fichero.
C        Nnod:       Variable que almacena el nmero total de nodos de
C                    la malla.
C        Ntri:       Variable que almacena el nmero de tringulos de
C                    la malla.
C        Nod(1:3):   Es el vector que utilizamos para almacenar los
C                    nodos del tringulo a estudiar.
C
      REAL*8 F,X[ALLOCATABLE](:),Y[ALLOCATABLE](:),INTE_EX,INTE_VERT,
     +     INTE_PMED,X_VERT(1:3),Y_VERT(1:3),X_PMED(1:3),Y_PMED(1:3),
     +     MEDIDA,SUMA,X_NODO,Y_NODO
C
C        F:          Funcin a P1-interpolar.
C        X,Y:        Vectores en los que almacenamos las coordenadas de
C                    los nodos.
C        INTE_EX:    Es la variable que almacena el valor exacto de la
C                    integral.
C        INTE_VERT:  Almacena el valor aproximado de la integral,
C                    obtenido utilizando la frmula que emplea como
C                    nodos los vrtices.
C        INTE_PMED:  Almacena el valor aproximado de la integral,
C                    obtenido utilizando la frmula que emplea como
C                    nodos los puntos medios de los lados del tringulo.
C        X_VERT(1:3):Primeras coordenadas de los vrtices.
C        Y_VERT(1:3):Segundas coordenadas de los vrtices.
C        X_PMED(1:3):Primeras coordenadas de los puntos medios.
C        Y_PMED(1:3):Segundas coordenadas de los puntos medios.
C        MEDIDA:     Medida de cada tringulo de la malla.
C        SUMA:       Variable auxiliar.
C        X_NODO:     Primera coordenada del nodo en el que estamos.
C        Y_NODO:     Segunda coordenada del nodo en el que estamos.
C

C
C        Fin de la declaracin de variables; pasamos al cdigo del
C        programa en si.
C

C
C        Para ver los posibles colores, buscar en la ayuda
C        REMAPALLPALETTE.
C
      AUX=SETBKCOLOR(10)
      AUX=SETTEXTCOLOR(15)
C
      CALL CLEARSCREEN($GCLEARSCREEN)
C
C        Llamada al sistema para borrar la pantalla.
C
      WRITE(*,*)' '
      WRITE(*,*)' '
      WRITE(*,*)'    Introduzca el nombre del fichero que contiene los',
     +          ' datos (max. 80 car.):'
      WRITE(*,*)' '
C
C        Aqu leemos el nombre del fichero.
C
      READ(*,'(A)') FICHERO
C
C        Comprobacin de la existencia del fichero que introduce el
C        usuario.
C
      INQUIRE(FILE=FICHERO,EXIST=EXISTE)
      IF(.NOT.EXISTE) THEN
         AUX=SETBKCOLOR(12)
         CALL CLEARSCREEN($GCLEARSCREEN)
         WRITE(*,*)' '
         WRITE(*,*)' '
         WRITE(*,*)'    No existe el fichero ',FICHERO
         WRITE(*,*)'    Elija una de las siguientes opciones:'
      END IF
      DO WHILE(.NOT.EXISTE)
         WRITE(*,*)' '
         WRITE(*,*)' '
         WRITE(*,*)'          1-.   VOLVER A INTRODUCIR EL NOMBRE DEL',
     +             ' FICHERO'
         WRITE(*,*)'          2-.   SALIR DEL PROGRAMA'
         WRITE(*,*)' '
         READ(*,*) OPCION
         IF(OPCION.EQ.1) THEN
            AUX=SETBKCOLOR(10)
            CALL CLEARSCREEN($GCLEARSCREEN)
            WRITE(*,*)' '
            WRITE(*,*)' '
            WRITE(*,*)'    Introduzca el nombre del fichero que',
     +                ' contiene los datos:'
            WRITE(*,*)' '
            READ(*,'(A)') FICHERO
            INQUIRE(FILE=FICHERO,EXIST=EXISTE)
            IF(.NOT.EXISTE) THEN
               AUX=SETBKCOLOR(12)
               CALL CLEARSCREEN($GCLEARSCREEN)
               WRITE(*,*)' '
               WRITE(*,*)' '
               WRITE(*,*)'    No existe el fichero ',FICHERO
               WRITE(*,*)'    Elija una de las siguientes opciones:'
            END IF
         ELSE IF(OPCION.EQ.2) THEN
            STOP' '
         ELSE
            AUX=SETBKCOLOR(12)
            CALL CLEARSCREEN($GCLEARSCREEN)
            WRITE(*,*)' '
            WRITE(*,*)' '
            WRITE(*,*)'                     Elija una de las opciones',
     +                ' disponibles:'
         END IF
      END DO
C
C        Fin del menu de apertura al fichero.
C        Comenzamos la ejecucin de la prctica.
C
      AUX=SETBKCOLOR(10)
      CALL CLEARSCREEN($GCLEARSCREEN)
      WRITE(*,*)' '
      WRITE(*,*)' '
      WRITE(*,*)'    Introduzca el valor exacto de la integral:'
      WRITE(*,*)' '
      READ(*,*) INTE_EX
      AUX=SETBKCOLOR(9)
      CALL CLEARSCREEN($GCLEARSCREEN)
      OPEN(1,FILE=FICHERO)
C
C        Saltamos la primera lnea de comentario del fichero obtenido
C        del mallador.
C
      READ(1,'(A$)')
      READ(1,*) NNOD,NTRI
      ALLOCATE(X(1:NNOD),Y(1:NNOD))
C
C        Saltamos la segunda lnea de comentario del fichero obtenido
C        del mallador.
C
      READ(1,'(A$)')
C
C        Almacenamos en los vectores X e Y las coordenadas de los nodos.
C
      DO I=1,NNOD
         READ(1,*) X(I),Y(I)
      END DO
C
C        Saltamos la tercera lnea de comentario del fichero obtenido
C        del mallador.
C
      READ(1,'(A$)')
C
C        Inicializamos las variables necesarias para los clculos, as
C        como las coordenadas de los nodos para los mtodos de
C        integracin.
C
      INTE_VERT=0.
      INTE_PMED=0.
C
      X_VERT(1)=1.
      X_VERT(2)=0.
      X_VERT(3)=0.
      Y_VERT(1)=0.
      Y_VERT(2)=1.
      Y_VERT(3)=0.
C
      X_PMED(1)=.5
      X_PMED(2)=.5
      X_PMED(3)=0.
      Y_PMED(1)=0.
      Y_PMED(2)=.5
      Y_PMED(3)=.5
C
      DO I=1,NTRI
         READ(1,*) NOD(1),NOD(2),NOD(3)
C
C        Calculamos la medida de cada uno de los tringulos de la malla.
C
         MEDIDA=(((X(NOD(1))-X(NOD(3))) * (Y(NOD(2))-Y(NOD(3))))-
     +           ((X(NOD(2))-X(NOD(3))) * (Y(NOD(1))-Y(NOD(3)))))/2.
C
C        En este bucle empleamos la frmula en la que los nodos son los
C        vrtices de cada tringulo.
C
         SUMA=0.
         DO J=1,3
            X_NODO=(X(NOD(1))-X(NOD(3)))*X_VERT(J)+
     +             (X(NOD(2))-X(NOD(3)))*Y_VERT(J)+
     +             X(NOD(3))
            Y_NODO=(Y(NOD(1))-Y(NOD(3)))*X_VERT(J)+
     +             (Y(NOD(2))-Y(NOD(3)))*Y_VERT(J)+
     +             Y(NOD(3))
            SUMA=SUMA+F(X_NODO,Y_NODO)
         END DO
         INTE_VERT=INTE_VERT+SUMA*MEDIDA
C
C        En este bucle empleamos la frmula en la que los nodos son los
C        puntos medios de los lados de cada tringulo.
C
         SUMA=0.
         DO J=1,3
            X_NODO=(X(NOD(1))-X(NOD(3)))*X_PMED(J)+
     +             (X(NOD(2))-X(NOD(3)))*Y_PMED(J)+
     +             X(NOD(3))
            Y_NODO=(Y(NOD(1))-Y(NOD(3)))*X_PMED(J)+
     +             (Y(NOD(2))-Y(NOD(3)))*Y_PMED(J)+
     +             Y(NOD(3))
            SUMA=SUMA+F(X_NODO,Y_NODO)
         END DO
         INTE_PMED=INTE_PMED+SUMA*MEDIDA
      END DO
C
C        Ahora multiplicamos los resultados por el valor del peso, ya
C        que hemos sacado factor comn el peso.
C
      INTE_VERT=INTE_VERT/3.
      INTE_PMED=INTE_PMED/3.
C
      DEALLOCATE(X,Y)
C
C        Presentamos los resultados.
C
      WRITE(*,*)' '
      WRITE(*,*)' '
      WRITE(*,*)'    El valor de la integral exacta es:    ',INTE_EX
      WRITE(*,*)'    La integral con VERTICES es:          ',INTE_VERT
      WRITE(*,*)'    La integral con PUNTOS MEDIOS es:     ',INTE_PMED
      WRITE(*,*)' '
      WRITE(*,*)'    El error con VERTICES es:             ',
     +               INTE_EX-INTE_VERT
      WRITE(*,*)'    El error con PUNTOS MEDIOS es:        ',
     +               INTE_EX-INTE_PMED
      WRITE(*,*)' '
C
      DO I=100,1000,100
         CALL BEEPQQ(I,10)
      END DO
C
      END